﻿using System.Linq;
using Windows.ApplicationModel;
using Windows.UI.Xaml.Navigation;
using UniversalSample.Commons;
using UniversalSample.Design;
using UniversalSample.Models;

namespace UniversalSample.ViewModels
{
    /// <summary>
    ///     ClassDetailPage ViewModel
    /// </summary>
    public class ClassDetailPageVM : ViewModelBase
    {
        private ClassM _currentClass;

        /// <summary>
        ///     Constructor
        /// </summary>
        public ClassDetailPageVM()
        {
            Title = "Class detail page";

            if (DesignMode.DesignModeEnabled)
            {
                //디자인 타임에서는 첫번째 데이터를 이용한다.
                CurrentClass = DesignDatas.GetClassList().First();
            }
        }

        /// <summary>
        ///     Current Class
        /// </summary>
        public ClassM CurrentClass
        {
            get { return _currentClass; }
            set
            {
                _currentClass = value;
                OnPropertyChanged();
            }
        }

        /// <summary>
        ///     Navigating
        /// </summary>
        /// <param name="e"></param>
        protected override void OnNavigating(NavigatingCancelEventArgs e)
        {
            CurrentClass = null;
        }

        /// <summary>
        ///     Navigated
        /// </summary>
        /// <param name="e"></param>
        protected override void OnNavigated(NavigationEventArgs e)
        {
            if (e.NavigationMode == NavigationMode.New)
            {
                CurrentClass = e.Parameter as ClassM;
            }
        }
    }
}